package nl.amis.infrastructure;

import java.io.IOException;

import java.util.Collection;
import java.util.Map;
import java.util.Set;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class SecuritySupporter implements Map {

    private boolean roleBasedAuthorization;

    public SecuritySupporter() {
    }
    public void setRoleBasedAuthorization(boolean roleBasedAuthorization) {
        this.roleBasedAuthorization = roleBasedAuthorization;
    }

    public boolean isRoleBasedAuthorization() {
        return roleBasedAuthorization;
    }
    
    public boolean isUserInRole(String role) {        
      return FacesContext.getCurrentInstance().getExternalContext().isUserInRole(role);
    }
    
    public String logout() throws IOException {
        ExternalContext ectx =
        FacesContext.getCurrentInstance().getExternalContext();
        HttpServletResponse response =
        (HttpServletResponse)ectx.getResponse();
        HttpSession session = (HttpSession)ectx.getSession(false);
        session.invalidate();
        // redirect is with regard to current page
        // if we want to use an absolute path (starting with /), then we have 
        // to include the context root such as SecureWebApp-SecureApp-context-root
        response.sendRedirect("../PublicPage.jspx");
        return null;
        }

    public int size() {
        return 0;
    }

    public boolean isEmpty() {
        return false;
    }

    public boolean containsKey(Object key) {
        return false;
    }

    public boolean containsValue(Object value) {
        return false;
    }

    public Object get(Object key) {       
        return (roleBasedAuthorization?isUserInRole((String)key):true);
    }

    public Object put(Object key, Object value) {
        return null;
    }

    public Object remove(Object key) {
        return null;
    }

    public void putAll(Map t) {
    }

    public void clear() {
    }

    public Set keySet() {
        return null;
    }

    public Collection values() {
        return null;
    }

    public Set entrySet() {
        return null;
    }

}
